#ifndef HBWIDGET_H
#define HBWIDGET_H
#include <QtWidgets/QMainWindow>  
#include <QtWidgets/QAction>
#include <QtPrintSupport/QPrinter>
#include <QtWidgets/QToolBar>
#include <QtWidgets/QLabel>

class QProgressBar;
class LCDRange;
class MoneyMarket;
class CommodityMarket;
class ISLMField;
class Equilibrium;
class NewWindow;
class QGroupBox;
class QVBoxLayout;
class QRadioButton;

class HBWidget : public QMainWindow
{
  Q_OBJECT
  public:
    HBWidget(QWidget *parent = 0);
  public slots:
    void about();
    void aboutQt();
    void whatsThis();
    void Reset();
    void ExMarket();
    void ImMarket();
    void EconOpenClosed();
    void GrowthSimulation();
    void FixedPrice();
    void wminClicked();
    void ISCurveVersion();
    void HintLinesOnOff();
    void TooltipsOnOff();
    void ReverseScreen();
    void WidgetPositions();
    void PrinterOutput();
    void KeynesMessage();
  protected slots:
    void LMMarketChanged();
    void ISMarketChanged();
    void ISLMChanged( double );
    void aggrMarketChanged();
  private slots:
    void updateStatusBar( const QString& );
    void updateProgress( int );
  private:
    void createActions();
    void createMenus();
    void createToolBars();
    void createStatusBar();
    QAction *resetAction, *exportAction, *importAction, *exitAction;
    QAction *whatisAction, *aboutQtAction, *aboutmacroAction;
    QAction *tradeonoffAction, *hintlinesonoffAction, *fixedpricemodelAction,
      *screenAction, *tooltipsonoffAction,
      *adjustPAction, *adjustExAction, *adjustMPAction, *adjusteAction,

      *growthAction, *IS_CAction, *IS_SAction, *printAction;
    QMenu *fileMenu, *helpMenu, *optionsMenu;
    QToolBar *HBToolBar;
    QLabel *messageLabel;
    QProgressBar *ShowProgress;
    QRadioButton *keynes1, *keynes2, *keynes3, *keynes4;
    LCDRange *V__LCD, *M_LCD, 
      *C0_LCD, *G_LCD, *t_LCD, *c_LCD,
      *K_LCD,  *P_LCD, *w_LCD, *e_LCD, *alpha_LCD;
    MoneyMarket *LMMarket;
    CommodityMarket *ISMarket;
    ISLMField       *ISLMMarket;
    Equilibrium     *aggrMarket;
    NewWindow       *w1, *w2;
    QGroupBox *rb ;
    QPrinter *printer;
    double SCALE, hskip;
    bool isOpen, DrawHintLines, ShowToolTips, ShowExPostIdentity, SmallScreen,
      FPM_ID;
    int WindowWidth, WindowHeight;
};

#endif
