#ifndef ISLM_H
#define ISLM_H

#include <QtCore/QString>
#include <QtWidgets/QWidget>
#include <QtGui/QMouseEvent>
#include <QtWidgets/QMessageBox>

class QPainter ;
class CommodityMarket;

class ISLMField : public QWidget
{
  Q_OBJECT
  public:
    ISLMField( QWidget *parent=0 );
    void DrawAxes( QPainter * );
    void paintISLM( QPainter * );
    double YDEqCalc();
    double YDEq, iEq;
    double s;
  public slots:
    void set_e( int );
    void InitialValues();
    void HintLines( bool );
    void Resolution( bool );
    void ISChanged( double, double, double, double,
		    bool, double, double );
    void Z0CurveChanged( double *, double *);
    void LMChanged( double, double, double, double, double, double);
    void AdjustmentMP();
    void AdjustmentERate();
    void FPMChanged( int );
  signals:
    void NewEquilibrium( double *, bool ); 
    void MChanged( int );
    void eChanged( int );
    void AdjustPriceLevel( int );
    void YDEqChanged( double );
    void EqValuesChanged( double, double );
    void explain( const QString& );
    void updateProgressBar( int );
  protected:
    void paintEvent( QPaintEvent * );
    void mousePressEvent( QMouseEvent * );
  private:
    QMessageBox *helpmessage;
    CommodityMarket *ISMarket;
    int e_h, FPM_ID ;
    void DrawCurve( QPainter * , QPolygon, QColor ); // alt QPointArray
    double k, iMIN1, iMAX1,iMIN2, iMAX2, P, M, ERate, SCALE; 
    int CENTER;
    double delta, LS0, rho, YatiMAXonLM, YatiMINonLM, YatiMAXonIS;
    double Yscaling, iscaling, autDemand, YMAX;
    double Z0Coor[2][150], ISCoor[2][150];
    bool OpenEconomy, HINTFLAG ;
    QPoint Origin ;
    QPoint *points;
};
#endif // ISLM_H
