#ifndef COMMODITYMARKET_H
#define COMMODITYMARKET_H

#include <QtWidgets/QWidget>
#include <QtWidgets/QMessageBox>   
#include <QtGui/QMouseEvent>
#include <QtGui/QPixmap>

class QPainter ;

class CommodityMarket : public QWidget
{
  Q_OBJECT
  public:
    CommodityMarket( QWidget *parent=0 );
    void DrawAxes( QPainter * );
    void paintCommodityMarket( QPainter * );
    void UpdateISMarket( double, double ); 
    void GrowthValues();
    void ReadParam( double Param[8] );
    double BoPA( double, double, double, double, double );
    double I( double );
    double C( double );
    double S( double );
    double Y( double, double, double, double, double, double, double, double );
    double tax, c, s, autDemand, rho;
  public slots:
    void set_c( int );
    void set_t( int );
    void set_C0( int );
    void set_G( int );
    void HintLines( bool );
    void Resolution( bool );
    void SavingsConsumption( bool );
    void OpenClosedEconomy( bool );
    void InitialValues( int );
    void IautChanged( double, double, double );
    void EqValuesChanged( double, double );
    void AdjustmentEx();
  signals:
    void cChanged( int );
    void tChanged( int );
    void C0Changed( int );
    void GChanged( int );
    void ISMarket2ISLM( double, double, double, double,
			bool, double, double );
    void ZCurve2ISLM( double *, double * );
    void explain( const QString& );
  protected:
    void paintEvent( QPaintEvent * );
    void mousePressEvent( QMouseEvent * );
    void mouseMoveEvent( QMouseEvent * );
    void resizeEvent(QResizeEvent *);
  private:
    int c_h, t_h, C0_h, G_h ;
    bool InViewOfSavings, OpenEconomy, HINTFLAG ;
    double P, ERate, Caut, I0, Iaut, G, iMIN, iMAX, YMAX, SCALE,
        Yscaling, iscaling, YRand, YatiMAX, IatiMIN, ihint, Yhint ;
    int CENTER;
    void ZEICHNEN( QPainter * , QPolygon, QColor );   //alt QPointarry
    QPoint Origin;
    QMessageBox *helpmessage;
    QPixmap HBpixmap;
};

#endif
