#ifndef LCDRANGE_H
#define LCDRANGE_H

#include <QtWidgets/qwidget.h>
#include <math.h>
#include <stdio.h>

#include <QtWidgets/QLabel>

class QLCDNumber;
class QScrollBar;

class LCDRange : public QWidget
{
  Q_OBJECT
  public:
    LCDRange( QWidget *parent=0 );
    LCDRange( const char *s, QWidget *parent=0 );
    int         value() const;
    const char *text()  const;
  public slots:
    void setValue( int );
    void setGValue( int );
    void setVValue( int );
    void setPValue( int );
    void setRange( int minVal, int maxVal );
    void setText( const char * );
  signals:
    void NewVal( int );
  protected:
    void resizeEvent( QResizeEvent * );
  private:
    void init();
    QScrollBar  *sBar;
    QLCDNumber  *lcd;
    QLabel      *label;
};
#endif
