#ifndef MONEYMARKET_H
#define MONEYMARKET_H

#include <QtWidgets/QWidget>
#include <QtGui/QMouseEvent>
#include <QtWidgets/QMessageBox>

class QPainter ;
class ISLMField ;

class MoneyMarket : public QWidget
{
  Q_OBJECT
  public:
    MoneyMarket( QWidget *parent=0 );
    void DrawAxes( QPainter * );
    void paintMoneyMarket( QPainter * );
    void UpdateLMMarket( double ); 
  public slots:
    void set_k( int );
    void set_M( int );
    void InitialValues( int );
    void HintLines( bool );
    void Resolution( bool );
    void EqValuesChanged( double, double );
  signals:
    void LMMarket2ISLM( double, double, double, double, double, double);
    void kChanged( int );
    void MChanged( int );
    void explain( const QString& );
  protected:
    void paintEvent( QPaintEvent * );
    void mousePressEvent( QMouseEvent * );
    void mouseMoveEvent( QMouseEvent * );
  private:
    int k_h, M_h;
    bool HINTFLAG;
    double k, M, P, YMAX, iMIN, iMAX, ihint, Yhint, SCALE, LS_kink;
    double delta, LS0, Yscaling, iscaling; 
    int CENTER;
    QMessageBox *helpmessage;
    QPoint Origin;
    ISLMField *ISLMMarket;
};

#endif 
