#include "WorldMarket.h"
#include "ISMarket.h"
#include <qpixmap.h>
#include <stdio.h>

const double 
  ai1=0.0029902, bi1=0.000006536, ci1= 0.695, di1=0.0006,
  ai2=0.0028239, bi2=0.00000179,  ci2=-0.245, di2=0.00058;

NewWindow::NewWindow( QWidget *parent )
          : QWidget( parent ) 
{
  setMinimumSize( 490, 200 );
  setGeometry( 0, 0, 490, 220 );
  ExportID = false;
  ImportID = false;
  ERate = 1.;
  P1 = 1.;
  Y1 = 1000.;
  ae1=0.0080854; ce1=0.07887;
  ae2=0.0153333; ce2=-5.14365;
}
void NewWindow::paintEvent( QPaintEvent * ) 
{
  QPainter r( this );  
  r.setBrush(QBrush("#fffff0"));
  r.drawRect( 0, 0, 490, 199 );           
  QString HBString;
  r.drawText( 150, 170, "x" ); r.drawText(  20, 175, tr("domestic market") );
  r.drawText( 310, 170, "x" ); r.drawText( 210, 175, tr("world market") );
  r.drawText( 470, 170, "x" ); r.drawText( 370, 175, tr("foreign market") );
  r.drawText( 2,   13, "p" );
  r.drawText( 160, 13, "p" );
  r.drawText( 307, 13, "e p" );
  r.drawLine(10,10,10,160);   r.drawLine(10,160,160,160);
  r.drawLine(170,10,170,160); r.drawLine(170,160,320,160);
  r.drawLine(330,10,330,160); r.drawLine(330,160,480,160);
  if (ExportID == true)  paintExportMarket( &r ) ; 
  if (ImportID == true)  paintImportMarket( &r ) ; 
}
void NewWindow::paintExportMarket( QPainter *r ) 
{
  const double be1=0.00002401, de1=0.0022371, be2=0.00001, de2=0.0044291;
  double Pscaling = 150. / 3.,
    xmax1 = 500.,  xscaling1 = 150. / xmax1,
    xmax2 = 200.,  xscaling2 = 150. / xmax2,
    xmax3 = 1800., xscaling3 = 150. / xmax3,
    Y2 = 4500., P2 = 2., temp;
  /*
  p1 = P1 * Y1 * ( a1 - b1 * x1D ) ;
  p1 = P1      * ( c1 + d1 * x1S ) ;

  p2 = P2 * Y2 * ( a2 - b2 * x2D ) ;
  p2 = P2      * ( c2 + d2 * x2S ); 
  */
  r->drawText( 305, 185, "200" );
  r->setPen(Qt::red);
  r->drawText( 145, 185, "500" );
  temp=ae1/be1;
  double PA = P1 * Pscaling ;
  r->drawLine(10,     
	      160-int(PA * Y1 * ae1), 
	      10 +int(xscaling1 * temp ), 
	      160-int(PA * Y1 * ( ae1 - be1 * temp ))); 
  r->drawLine(10,     
	      160-int(PA * ce1), 
	      10+int(xscaling1 * xmax1 ), 
	      160-int(PA * (de1 * xmax1 + ce1))); 
  r->drawLine(170,     
	      160-int(PA * Y1 * (be1*ce1 + ae1*de1)/(de1 + be1 * Y1) ), 
	      170+int(xscaling2 * xmax2 ), 
	      160-int(PA * Y1 * (be1*ce1 + ae1*de1 + be1*de1 * xmax2)
		      / (de1 + be1 * Y1) )); 
  /***************************************************************************/
  r->setPen(Qt::blue);
  double PB = Pscaling * P2 * ERate ;
  r->drawText( 460, 185, "1800" );
  r->drawLine(170,     
	      160-int(PB*Y2 * (be2*ce2 + ae2*de2 - be2*de2 * 0.)
	      / (de2 + be2 * Y2) ), 
	      170+int(xscaling2 * xmax2 ), 
	      160-int(PB*Y2 * (be2*ce2 + ae2*de2 - be2*de2 * xmax2)
	      / (de2 + be2 * Y2)));

  if ( P1      * Y1 * (be1*ce1 + ae1*de1) / (de1 + be1 * Y1) > 
       P2*ERate* Y2 * (be2*ce2 + ae2*de2) / (de2 + be2 * Y2))
    fprintf(stderr,"\n\nKein Exportmarkt mehr!\n\n");

  double PY1 = P1 * Y1 ;
  double PY2 = ERate * P2 * Y2 ;

  double EXport = -( (PY1*(be1*ce1 + ae1*de1)/(de1 + be1*Y1) 
		     - PY2*(be2*ce2 + ae2*de2)/(de2 + be2*Y2) )
		  /( PY1*be1*de1/(de1 + be1*Y1) + PY2*be2*de2/(de2 + be2*Y2)));
  double pExport = PY1 *(be1*ce1 + ae1*de1 + be1*de1*EXport)/(de1 + be1*Y1);
  temp = pExport*(pExport/(P1*de1)-ce1/de1-ae1/be1);
  if (temp<0)  fprintf(stderr,"autonomer Export jetzt negativ: %f\n",temp);
  temp=ae2/be2;
  r->drawLine(330,     
	      160-int(PB * Y2 * ae2 ), 
	      330+int(xscaling3 * temp ), 
	      160-int(PB * Y2 * (ae2- be2 * temp) ));
  temp=-ce2/de2;
  r->drawLine(330+int(xscaling3 * temp),      
	      160-int(PB * (ce2 + de2 * temp)), 
	      330+int(xscaling3 * xmax3 ), 
	      160-int(PB * (ce2 + de2 * xmax3)));   
  r->setPen(Qt::black);
}
void NewWindow::paintImportMarket( QPainter *r ) 
{
  double Pscaling = 150. / 4.5,
    xmax1 = 500.,  xscaling1 = 150. / xmax1,
    xmax2 = 250.,  xscaling2 = 150. / xmax2,
    xmax3 = 1800., xscaling3 = 150. / xmax3,
    Y2 = 4500., P2 = 2., temp;
  /*
  p1 = P1 * Y1 * ( a1 - b1 * x1D ) ;
  p1 = P1 * ( c1 + d1 * x1S ) ;

  p2 = P2 * Y2 * ( a2 - b2 * x2D ) ;
  p2 = P2 * ( c2 + d2 * x2S ); 
  */
  r->drawText( 305, 185, "250" );
  r->setPen(Qt::red);
  r->drawText( 145, 185, "500" );
  temp=ai1/bi1;
  double PA = P1 * Pscaling ;
  r->drawLine(10,     
	      160-int(PA * Y1 * ai1), 
	      10+int(xscaling1 * temp ), 
	      160-int(PA * Y1 * ( ai1 - bi1 * temp ))); 
  r->drawLine(10,     
	      160-int(PA * ci1), 
	      10+int(xscaling1 * xmax1 ), 
	      160-int(PA * ( ci1 + di1 * xmax1 )) ); 
  r->drawLine(170,     
	      160-int(PA * Y1 * (bi1*ci1 + ai1*di1 - bi1*di1 * 0)
			       / (di1 + bi1 * Y1) ), 
	      170+int(xscaling2 * xmax2 ), 
	      160-int(PA * Y1 * (bi1*ci1 + ai1*di1 - bi1*di1 * xmax2)
			       / (di1 + bi1 * Y1) )); 
  /***************************************************************************/
  r->setPen(Qt::blue);
  double PB = Pscaling * P2 * ERate ;
  r->drawLine(170,     
	      160-int(PB * Y2 * (bi2*ci2 + ai2*di2 + bi2*di2 * 0)
			       / (di2 + bi2 * Y2) ), 
	      170+int(xscaling2 * xmax2 ), 
	      160-int(PB * Y2 * (bi2*ci2 + ai2*di2 + bi2*di2 * xmax2)
			       / (di2 + bi2 * Y2) )); 
  r->drawText( 460, 185, "1800" );
  temp = -ci2/di2; // p=0
  r->drawLine(330+int(xscaling3 * temp ),      
	      160-int(PB * (ci2 + di2 * temp)), 
	      330+int(xscaling3 * xmax3 ), 
	      160-int(PB * (ci2 + di2 * xmax3)));
  temp = ai2/bi2; // p=0
  r->drawLine(330+int(xscaling3 * 0. ),  
	      160-int(PB * Y2 * (ai2 - bi2 * 0.)), 
	      330+int(xscaling3 * temp ), 
	      160-int(PB * Y2 * (ai2 - bi2 * temp)));
  r->setPen(Qt::black);
}
void NewWindow::WhatMarket( int MarketType, 
			    double ERateNew,
			    double P1New,
			    double Y1New) 
{
  double Param[8];
  ERate = ERateNew ;
  P1 = P1New ;
  Y1 = Y1New ;
  if (MarketType==0) {                // export market
    ISMarket->ReadParam( Param );
    ae1 = Param[0] ;                  // adjusted autonomous exports
    ce1 = Param[1] ;
    ae2 = Param[2] ;
    ce2 = Param[3] ;
    ExportID = true;
    ImportID = false;
  }
  else {                              // import market
    ExportID = false;
    ImportID = true;
  }  
  repaint();
}
