#include <QtWidgets/QApplication>
//#include <QCDEStyle>
//#include <QtWidgets/QStyle>
#include <QtCore/QFileInfo>
#include <QtWidgets/QMessageBox>    
#include <QtCore/QTranslator>
#include "00FrontEnd.h"
#include "stdio.h"

int main( int argc, char **argv ) 
{
  int NumberOfArguments = 1;
  QApplication HBWindow( NumberOfArguments, argv );
  //  HBWindow.setStyle(new QCDEStyle);
  //  HBWindow.setStyle(new QMotifStyle);
  QString lang;
  if ( argc != 2 ) {
    int i = QMessageBox::information(0, "Language?", 
				     "Please choose the language you prefer.",
				     "Deutsch", "English" );
    switch ( i ) {
    case 0: lang = "de"; break;
    case 1: lang = "en"; break;
    }
  } else {
    lang = argv[1];
  }
#if __GNUG__ /* GNU C++ Compiler Linux */
  QString lfile = "Makroprogramm_" + lang + ".qm";
#else
  QString lfile = "Makroprogramm_" + lang + ".qm";
#endif
  QFileInfo fi( lfile );
  if ( !fi.exists() ) {
    QMessageBox::warning( 0, "File error",
		 QString("Cannot find translation for language: "+lang+
		 "\n(try 'de', 'en' or 'no')") );
    return 0;
  }

  QTranslator translator;
  translator.load( lfile, "." );
  HBWindow.installTranslator( &translator );

  HBWidget w;  // QMainWindow in FrontEnd.h
  w.setGeometry( 50, 50, 800, 600 );
  w.setMinimumSize( 800, 600 );
  w.show();
  HBWindow.connect(&HBWindow,SIGNAL(lastWindowClosed()),
		   &HBWindow,SLOT(quit()));
  return HBWindow.exec();
}



